=== debian/changelog ===
calamares (3.2.32.1-3) unstable; urgency=medium

  * No changes version bump

 -- Jonathan Carter <jcc@debian.org>  Wed, 21 Oct 2020 09:28:26 +0200

calamares (3.2.32.1-2) unstable; urgency=medium

  * Small changes upload for kpmcore ABI bump (to version 10)
  * Replace DEB_BUILD_OPTIONS with DEB_BUILD_MAINT_OPTIONS in
    debian/rules
  * Use secure copyright format URI

 -- Jonathan Carter <jcc@debian.org>  Sun, 18 Oct 2020 18:31:41 +0200

calamares (3.2.32.1-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Sat, 17 Oct 2020 17:55:22 +0200

calamares (3.2.32-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Fri, 16 Oct 2020 17:56:48 +0200

calamares (3.2.31-2) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Wed, 07 Oct 2020 19:26:25 +0200

calamares (3.2.30-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Mon, 07 Sep 2020 22:25:17 +0200

calamares (3.2.28.3-2) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Wed, 19 Aug 2020 14:13:37 +0200

calamares (3.2.28.2-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Fri, 14 Aug 2020 11:09:21 +0200

calamares (3.2.28.1-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Tue, 11 Aug 2020 11:48:45 +0200
