=== debian/changelog ===
calamares (3.2.33-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Tue, 10 Nov 2020 13:59:04 +0200
